{% extends "base.html" %} {% block title %}
<title>我的订单</title>
{% endblock %} {% block css %} {{ super() }}
<link rel="stylesheet" type="text/css" href="{{url_for('user.static',filename='css/Switch.css')}}" />
{% endblock %} {% block header %} {{ super() }} {% endblock %} {% block main %}
<main>
    <section class="shop--area shop-right-sidebar pt-90 pb-90">
        <div class="container">
            <div class="row justify-content-center">
                <div class="col-xl-3 col-lg-3 col-md-3 col-sm-12">{% include "cont_side.html" %}</div>
                <div class="col-xl-9 col-lg-9 col-md-9 col-sm-12">
                    <div class="cart-wrapper">
                        <div class="table-responsive">
                            <table class="table mb-0">
                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">待确认订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete">快捷操作</th>
                                    </tr>
                                </thead>
                                <tbody id="my_order_wait_confirm"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">待完成订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete">快捷操作</th>
                                    </tr>
                                </thead>
                                <tbody id="my_order_confirmed"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">已完成订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete">快捷操作</th>
                                    </tr>
                                </thead>
                                <tbody id="my_order_done"></tbody>

                                <thead>
                                    <tr>
                                        <th class="product-thumbnail"></th>
                                        <th class="product-name">已取消订单</th>
                                        <th class="product-name"></th>
                                        <th class="product-delete">快捷操作</th>
                                    </tr>
                                </thead>
                                <tbody id="my_order_cancel"></tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
</main>
{% endblock %} {% block footer %} {{ super() }} {% endblock %} {% block js %} {{ super() }}

<script type="text/javascript" charset="utf-8">
    let debug = 0;
    let current_user_id = "{{current_user.id|safe}}";
    $(document).ready(function () {
        let url = "/api/get_order";
        if (debug) url = `http://127.0.0.1:4523/mock/927026${url}`;
        $.ajax({
            url: url,
            type: "GET",
            async: false, // 当需要将值传给函数外部时需要强制同步
            success: function (ret) {
                if (ret.statusCode !== 200) {
                    suspend("alert-danger", ret.message);
                    sleep(500).then(() => {
                        window.location.href = "{{url_for('index')}}";
                    });
                } else {
                    let mytbody;

                    for (let i = 0; i < ret.data.length; i++) {
                        if (ret.data[i].state === 0) mytbody = $("#my_order_wait_confirm");
                        else if (ret.data[i].state === 1) mytbody = $("#my_order_confirmed");
                        else if (ret.data[i].state === 2) mytbody = $("#my_order_done");
                        else if (ret.data[i].state === -1) mytbody = $("#my_order_cancel");

                        let order_id = ret.data[i].order_id;
                        let item_id = ret.data[i].item_id_list[0]; //目前还只有一个商品信息
                        let pic_url = "/api/get_item_head_pic";
                        let purl = "";
                        if (debug) pic_url = `http://127.0.0.1:4523/mock/927026${pic_url}`;
                        $.ajax({
                            url: pic_url,
                            type: "GET",
                            data: { item_id: item_id },
                            async: false, // 当需要将值传给函数外部时需要强制同步
                            success: function (pic_ret) {
                                if (pic_ret.statusCode === 200) purl = pic_ret.data.url;
                            },
                        });
                        let item_url = "/api/get_item_info";
                        let item_name = "";
                        let item_desc = "";
                        let other_user_id = "";
                        let state_message = "";
                        if (debug) item_url = `http://127.0.0.1:4523/mock/927026${item_url}`;
                        $.ajax({
                            url: item_url,
                            type: "Get",
                            data: { item_id: item_id },
                            async: false, // 当需要将值传给函数外部时需要强制同步
                            success: function (item_ret) {
                                if (item_ret.statusCode === 200) {
                                    item_name = item_ret.data.name;
                                    item_desc = item_ret.data.description;
                                    if (current_user_id === item_ret.data.user_id)
                                        //如果是商家
                                        other_user_id = ret.data[i].user_id;
                                    else other_user_id = item_ret.data.user_id;

                                    let str = `
                                    <tr id="my_order${order_id}">
                                        <td class="product-thumbnail" id="order_item_pic${order_id}">
                                            <a href="/item/content/${item_id}"><img src="${purl}" alt=""></a>
                                        </td>
                                        <td class="product-name" id="order_item_data${order_id}">
                                            <h4><a href="/item/content/${item_id}">${item_name}</a></h4>
                                            <br/>
                                            <h4><a href="/user/${other_user_id}/user_info">${other_user_id}</a></h4>
                                        </td>
                                        <td class="product-name">
                                            <h4><a href="/order/${order_id}">订单详情</a></h4>
                                        </td>
                                        <td class="product-delete">
                                            <button class="btn" id="confirm${order_id}" onclick="change_state('${order_id}',1)">确认订单</button>
                                            <button class="btn" id="complete${order_id}" onclick="change_state('${order_id}',2)">完成订单</button>
                                            <button class="btn" id="cancel${order_id}" onclick="change_state('${order_id}',-1)">取消订单</button>
                                        </td>
                                    </tr>`;
                                    mytbody.append(str);

                                    //订单状态逻辑
                                    console.log(ret.data[i])
                                    if (ret.data[i].state === 0) {
                                        state_message = "等待商家确认";
                                        if (current_user_id !== item_ret.data.user_id) {
                                            //当前用户不是卖家
                                            $(`#confirm${order_id}`).prop("hidden", "hidden");
                                        }
                                        $(`#complete${order_id}`).prop("hidden", "hidden");
                                    } else if (ret.data[i].state === 1) {
                                        state_message = "等待收货方完成";
                                        if ((current_user_id != ret.data[i].user_id && item_ret.data.type === 0) || (current_user_id != item_ret.data.user_id && item_ret.data.type === 1)) {
                                            //当前用户不是收货方
                                            $(`#complete${order_id}`).prop("hidden", "hidden");
                                        }
                                        $(`#confirm${order_id}`).prop("hidden", "hidden");
                                    } else if (ret.data[i].state === -1) {
                                        state_message = "已被取消";
                                        $(`#cancel${order_id}`).prop("hidden", "hidden");
                                        $(`#complete${order_id}`).prop("hidden", "hidden");
                                        $(`#confirm${order_id}`).prop("hidden", "hidden");
                                    } else if (ret.data[i].state === 2) {
                                        state_message = "已完成";
                                        $(`#cancel${order_id}`).prop("hidden", "hidden");
                                        $(`#complete${order_id}`).prop("hidden", "hidden");
                                        $(`#confirm${order_id}`).prop("hidden", "hidden");
                                    }
                                }
                            },
                        });

                        let p_tr = $(`#my_order${order_id}`);
                    }
                }
            },
        });
    });
    function change_state(order_id, state) {
        //修改订单状态
        $.ajax({
            url: "/api/change_order_state",
            type: "put",
            data: JSON.stringify({ order_id: order_id, state: state }),
            contentType: "application/json;charset=utf-8",
            processData: false,
            success: function (ret) {
                if (ret.statusCode === 200) {
                    suspend("alert-success", ret.message);
                    sleep(500).then(() => {
                        window.location.reload();
                    });
                } else {
                    suspend("alert-danger", ret.message);
                }
            },
        });
    }
</script>
{% endblock %}
